<?php
namespace Teknisa\PLA\Modules\Cardapio\Controllers;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;

class Pla00400 extends \Zeedhi\Framework\Controller\Report {

    protected $novoCodigo;
    protected $procedureNutriente;
    protected $parameterBagColumns;
    protected $entityManager;
    protected $qr2Strategy;
    protected $birtStrategy;
    protected $environment;
    protected $crudService;
    

    public function __construct($reportService, $novoCodigo, $parameterBagColumns, $entityManager, $qr2Strategy, $birtStrategy, $environment, $crudService) {
        
        $this->novoCodigo          = $novoCodigo;
        $this->entityManager       = $entityManager;
        $this->qr2Strategy         = $qr2Strategy;
        $this->reportService       = $reportService;
        $this->parameterBagColumns = $parameterBagColumns;
        $this->birtStrategy        = $birtStrategy;
        $this->environment         = $environment;
        $this->crudService         = $crudService;

    }

    protected $reportMapping = array (
    'pla00400' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'       => 'P_CDFILIAL',
                'DTINICIAL'      => 'P_DTINICIAL',
                'DTFINAL'        => 'P_DTFINAL',
                'L_SERVICO'      => 'L_SERVICO',
                'CDDIETA'        => 'P_CDDIETA',
                'DSQUEBRAPAGINA' => 'P_QUEBRA',
                'DSNUTRI'        => 'P_NUTRI',
                'DSIMPNDPCAL'    => 'P_NDPCAL',
                'FILNDPCAL'      => 'P_FILNDPCAL',
                'DSIMPRIMEMENS'  => 'P_MENS',
                'NRSEQUNUTR'     => 'P_NRSEQUNUTR',
                'SGUNIDADE1'     => 'P_SGUNIDADE1',
                'SGUNIDADE2'     => 'P_SGUNIDADE2',
                'SGUNIDADE3'     => 'P_SGUNIDADE3',
                'SGUNIDADE4'     => 'P_SGUNIDADE4',
                'NMREDUZIDO1'    => 'P_NMREDUZIDO1',
                'NMREDUZIDO2'    => 'P_NMREDUZIDO2',
                'NMREDUZIDO3'    => 'P_NMREDUZIDO3',
                'NMREDUZIDO4'    => 'P_NMREDUZIDO4',
                'PRATOOPCAONUTR' => 'P_PRATOOPCAONUTR',
                'NRORG'          => 'NRORG',
                'IMPNMFANTASIA'  => 'P_IMPNMFANTASIA'
            ),
        ),
        'pla00401' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'       => 'P_CDFILIAL',
                'DTINICIAL'      => 'P_DTINICIAL',
                'DTFINAL'        => 'P_DTFINAL',
                'L_SERVICO'      => 'L_SERVICO',
                'CDDIETA'        => 'P_CDDIETA',
                'DSQUEBRAPAGINA' => 'P_QUEBRA',
                'DSNUTRI'        => 'P_NUTRI',
                'DSIMPNDPCAL'    => 'P_NDPCAL',
                'FILNDPCAL'      => 'P_FILNDPCAL',
                'DSIMPRIMEMENS'  => 'P_MENS',
                'NRSEQUNUTR'     => 'P_NRSEQUNUTR',
                'SGUNIDADE1'     => 'P_SGUNIDADE1',
                'SGUNIDADE2'     => 'P_SGUNIDADE2',
                'SGUNIDADE3'     => 'P_SGUNIDADE3',
                'SGUNIDADE4'     => 'P_SGUNIDADE4',
                'NMREDUZIDO1'    => 'P_NMREDUZIDO1',
                'NMREDUZIDO2'    => 'P_NMREDUZIDO2',
                'NMREDUZIDO3'    => 'P_NMREDUZIDO3',
                'NMREDUZIDO4'    => 'P_NMREDUZIDO4',
                'PRATOOPCAONUTR' => 'P_PRATOOPCAONUTR',
                'NRORG'          => 'NRORG',
                'IMPNMFANTASIA'  => 'P_IMPNMFANTASIA'
            ),
        ),
        'pla00402' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'       => 'P_CDFILIAL',
                'DTINICIAL'      => 'P_DTINICIAL',
                'DTFINAL'        => 'P_DTFINAL',
                'L_SERVICO'      => 'L_SERVICO',
                'CDDIETA'        => 'P_CDDIETA',
                'DSQUEBRAPAGINA' => 'P_QUEBRA',
                'DSNUTRI'        => 'P_NUTRI',
                'DSIMPNDPCAL'    => 'P_NDPCAL',
                'FILNDPCAL'      => 'P_FILNDPCAL',
                'NRSEQUNUTR'     => 'P_NRSEQUNUTR',
                'SGUNIDADE1'     => 'P_SGUNIDADE1',
                'SGUNIDADE2'     => 'P_SGUNIDADE2',
                'SGUNIDADE3'     => 'P_SGUNIDADE3',
                'SGUNIDADE4'     => 'P_SGUNIDADE4',
                'NMREDUZIDO1'    => 'P_NMREDUZIDO1',
                'NMREDUZIDO2'    => 'P_NMREDUZIDO2',
                'NMREDUZIDO3'    => 'P_NMREDUZIDO3',
                'NMREDUZIDO4'    => 'P_NMREDUZIDO4',
                'NRORG'          => 'NRORG',
                'IMPNMFANTASIA'  => 'P_IMPNMFANTASIA'
                )
        ),
        'PLA00403' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
                'CDFILIAL'       => 'P_CDFILIAL',
                'DTINICIAL'      => 'P_DTINICIAL',
                'DTFINAL'        => 'P_DTFINAL',
                'L_SERVICO'      => 'L_SERVICO',
                'DSQUEBRAPAGINA' => 'P_QUEBRA',
                'NRORG'          => 'NRORG',
                'IMPNMFANTASIA'  => 'P_IMPNMFANTASIA'
            )
        )
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $this->birtStrategy->setReportFormat($row['QR2TYPE']);
          
            $dateInicial = \DateTime::createFromFormat('d/m/Y', $row['DTINICIAL']);
            $dateFinal   = \DateTime::createFromFormat('d/m/Y', $row['DTFINAL']);
            
            $cdfilial    = $row['CDFILIAL'];
            $nrorg       = $row['NRORG'];
            $listaNutri = '';
            
            $nrlistaServ = $this->novoCodigo->getCodeByTableName('LISTA', $nrorg);
            $nutrientes = $this->nutrientesParamplaneja($nrorg, $cdfilial);
            if($nutrientes[0]["CDNUTRRELAT1"])  $listaNutri .= $nutrientes[0]["CDNUTRRELAT1"]."_";
            if($nutrientes[0]["CDNUTRRELAT2"])  $listaNutri .= $nutrientes[0]["CDNUTRRELAT2"]."_";
            if($nutrientes[0]["CDNUTRRELAT3"])  $listaNutri .= $nutrientes[0]["CDNUTRRELAT3"]."_";
            if($nutrientes[0]["CDNUTRRELAT4"])  $listaNutri .= $nutrientes[0]["CDNUTRRELAT4"]."_";
            
            $nrsequnutr = $this->novoCodigo->getCodeByTableName('CALCNUTR'.$row['CDFILIAL'], $row['NRORG']);

            $row['NMREDUZIDO1'] = $nutrientes[0]["NMREDUZIDO1"];
            $row['NMREDUZIDO2'] = $nutrientes[0]["NMREDUZIDO2"]; 
            $row['NMREDUZIDO3'] = $nutrientes[0]["NMREDUZIDO3"];
            $row['NMREDUZIDO4'] = $nutrientes[0]["NMREDUZIDO4"];

            $row['SGUNIDADE1']  = $nutrientes[0]["SG1"];
            $row['SGUNIDADE2']  = $nutrientes[0]["SG2"];
            $row['SGUNIDADE3']  = $nutrientes[0]["SG3"];
            $row['SGUNIDADE4']  = $nutrientes[0]["SG4"];
            
            $row['NRSEQUNUTR'] = $nrsequnutr;
            
            if($row['QR2TYPE'] === 'xlsx'){
                 $row['DSQUEBRAPAGINA'] = 'N';
            }

            if($row['L_SERVICO'] == 'T') {
                    $servicos = $this->retornaServicos($row['CDFILIAL'], $row['NRORG']);
            }
            else{
                $servicos = $row['L_SERVICO'];
            }
            $servicos = explode('_', $servicos);
             if($servicos[0]==""){
                  array_shift($servicos);
            }
            $this->insereLista($nrlistaServ, $servicos);
            
            $row['L_SERVICO']  = "_NRLISTA=".$nrlistaServ;
        
            if($row['DSNUTRI'] == 'S') {
                $connection = $this->entityManager->getConnection();
                $procedureNutriente = new StoredProcedure($connection, 'NUTRIENTE_DO_CARDAPIO_PLA');

                $procedureNutriente->addParam(new Param('P_FILIAL',     Param::PARAM_INPUT, $cdfilial,           Param::PARAM_TYPE_STR));
                $procedureNutriente->addParam(new Param('P_SERVICOS',   Param::PARAM_INPUT, $row['L_SERVICO'],   Param::PARAM_TYPE_STR));
                $procedureNutriente->addParam(new Param('P_NUTRIENTES', Param::PARAM_INPUT, $listaNutri,         Param::PARAM_TYPE_STR));
                $procedureNutriente->addParam(new Param('P_NRSEQUNUTR', Param::PARAM_INPUT, $nrsequnutr,         Param::PARAM_TYPE_STR));
                $procedureNutriente->addParam(new Param('P_IDNDPCAL',   Param::PARAM_INPUT, $row['DSIMPNDPCAL'], Param::PARAM_TYPE_STR));
                $procedureNutriente->addParam(new Param('P_DTINICIAL',  Param::PARAM_INPUT, $dateInicial->format('d/m/Y'), Param::PARAM_TYPE_STR));
                $procedureNutriente->addParam(new Param('P_DTFINAL',    Param::PARAM_INPUT, $dateFinal->format('d/m/Y'),   Param::PARAM_TYPE_STR));
                $procedureNutriente->execute();
            }

        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function nutrientesParamplaneja($nrorg, $cdfilial) {
        $sql = <<<SQL
            SELECT
               NUT1.NMREDUZIDO AS NMREDUZIDO1,
               NUT1.SGUNIDADE  AS SG1,
               PARAMPLANEJA.CDNUTRRELAT1,
               NUT2.NMREDUZIDO AS NMREDUZIDO2,
               NUT2.SGUNIDADE  AS SG2,
               PARAMPLANEJA.CDNUTRRELAT2,
               NUT3.NMREDUZIDO AS NMREDUZIDO3,
               NUT3.SGUNIDADE  AS SG3,
               PARAMPLANEJA.CDNUTRRELAT3,
               NUT4.NMREDUZIDO AS NMREDUZIDO4,
               NUT4.SGUNIDADE  AS SG4,
               PARAMPLANEJA.CDNUTRRELAT4
            FROM
               PARAMPLANEJA,
               NUTRIENTE NUT1,
               NUTRIENTE NUT2,
               NUTRIENTE NUT3,
               NUTRIENTE NUT4
            WHERE
               NUT1.NRORG(+) = PARAMPLANEJA.NRORG AND
               NUT2.NRORG(+) = PARAMPLANEJA.NRORG AND
               NUT3.NRORG(+) = PARAMPLANEJA.NRORG AND
               NUT4.NRORG(+) = PARAMPLANEJA.NRORG AND
               NUT1.CDNUTRIENTE(+) = PARAMPLANEJA.CDNUTRRELAT1 AND
               NUT2.CDNUTRIENTE(+) = PARAMPLANEJA.CDNUTRRELAT2 AND
               NUT3.CDNUTRIENTE(+) = PARAMPLANEJA.CDNUTRRELAT3 AND
               NUT4.CDNUTRIENTE(+) = PARAMPLANEJA.CDNUTRRELAT4 AND
               PARAMPLANEJA.CDFILIAL = :CDFILIAL AND
               PARAMPLANEJA.NRORG = :NRORG 
SQL;
        $params = array(
            'NRORG'        => $nrorg,
            'CDFILIAL'     =>$cdfilial
        );

        try {
            return $this->entityManager->getConnection()->fetchAll($sql, $params);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function retornaServicos($cdfilial, $nrorg) {
        $sql = <<<SQL
            SELECT CDSERVFILI
            FROM SERVICO
            WHERE CDFILIAL = :CDFILIAL
            AND NRORG = :NRORG
SQL;
        $params = array(
            'NRORG'        => $nrorg,
            'CDFILIAL'     =>$cdfilial
        );

        try {
            $lista = $this->entityManager->getConnection()->fetchAll($sql, $params);
            $str_lista = null;
            foreach($lista as $row){
                $str_lista = $str_lista.'_'.$row['CDSERVFILI'];
            }
            return $str_lista;
        } catch (\Exception $e) {
            throw $e;
        }
    }

    public function removeNutrtrab($nrsequnutr, $cdfilial) {
        $sql = "DELETE FROM NUTRTRAB 
                WHERE CDFILIAL = :CDFILIAL 
                    AND NRSEQUNUTR = :NRSEQUNUTR
                    AND NRORG = :NRORG";

        $params = array(
            'NRORG'        => $nrorg,
            'CDFILIAL'     => $cdfilial,
            'NRSEQUNUTR'   => $nrsequnutr,
        );
        try { 
            $query =  $this->entityManager->getConnection()->prepare($sql);
            $query->execute($execute);

        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    	private function insereLista($nrlista, $listaserv) {
		$rows = array();
		foreach($listaserv as $servico){
			array_push($rows,
				array(
					"NRLISTA" 	=> $nrlista,
					"CDLISTA" 	=> $servico,
					"__is_new"  => true
				)
			);
		}
		$dataSet = new DataSet(null, $rows);
		$request = new DTO\Request\DataSet($dataSet, '', '', '');
		$rowsToSave = $this->crudService->getRowsToSave($request, 'lista');
		$this->crudService->save('lista', $rowsToSave);
	}
}