<?php

namespace Teknisa\PLA\Modules\Prato\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;

class Pla01400TipoDePratoController {

	protected $connection;

	 public function __construct($connection) {
        $this->connection = $connection;
    }
    /**
     * @return o primeiro código disponível entre 0 e 99, 
     * desconsiderando registros não númericos, 
     * e com zeros do lado esquerdo caso seja necessário formatar o número para que o mesmo ocupe dois caracteres
     */ 
    public function getNextId(DTO\Request $request, DTO\Response $response){
        $query = "SELECT CDTIPOPRAT as newcode FROM tipoprat WHERE REGEXP_LIKE(CDTIPOPRAT,'^[0-9]+$') ORDER BY CDTIPOPRAT";
		$stmt = $this->connection->prepare($query);
		$stmt->execute();
		$result = $stmt->fetchAll();
		for($i =1; $i < sizeof($result);$i ++){
		    if(($result[$i]['NEWCODE'] - $result[$i-1]['NEWCODE'] > 1) 
		       && ($result[$i-1]['NEWCODE'] + 1 <= 99)){
		        $response-> addDataSet (
		           new DataSet("newcodeset",
		        		array("NEWCODE" => str_pad(($result[$i-1]['NEWCODE'] + 1), 2, "0", STR_PAD_LEFT))
		           )
		        );
		        return;
		    }
		}
        $response-> addDataSet (
		           new DataSet("newcodeset",
		        		array("NEWCODE" => "")
		           )
		 );
    }
}